/* 

measure()     Measure the energy, magnetization, and square of the 
	      magnetization, using either the Potts or Ising (Q=2)
	      forms for these.

magn()        Measure the anti-ferromagnetic magnetization.

*/

#include "comext.h"
#include <stdio.h>


measure(spin)
short spin[IMAX][JMAX];
{
   int bin[MAXQ];
   int i,j,n,sumspin;
   float spinmax;
   double sumenergy;
   float magn();

   sumenergy = 0.0; 

if ((Q == 2) && (glass || frustrated)) {

   /* Ising values for measurements */
   sumspin = 0;
   for (i=0;i<isiz;i++) {
   for (j=0;j<jsiz;j++) {
         sumspin += spin[i][j];
 	 if (spin[i][j] == spin[plusi(1)][j]) 
	    sumenergy += J[i][j][0];
	 else
	    sumenergy -= J[i][j][0];
	 if (spin[i][j] == spin[i][plusj(1)]) 
	    sumenergy += J[i][j][1];
	 else
	    sumenergy -= J[i][j][1];
   }}
   sumspin = (2 * sumspin) - sites;
   if (sumspin < 0) {
      sumspin *= -1;
   }
   mag[0] = (double)sumspin / volume;
}
else { 

   /* Potts values for measurements */
   for (n=0;n<Q;n++) bin[n] = 0;  /* initialize Q-state bin */
   for (i=0;i<isiz;i++) {
      for (j=0;j<jsiz;j++)  {
       	 bin[ spin[i][j] ]++;
 	 if (spin[i][j] == spin[plusi(1)][j]) sumenergy += J[i][j][0];
	 if (spin[i][j] == spin[i][plusj(1)]) sumenergy += J[i][j][1];
      }
   }
   for (n=0;n<Q;n++) Qspin[n] = (double)bin[n] / volume;
   /* Magnetization (spin taken in the preffered direction) */
   spinmax = Qspin[0];
   for (i=1;i<Q;i++)
      if (Qspin[i] > spinmax) {
        spinmax = Qspin[i];
      }
   mag[0] = ((Q*spinmax) - 1) / (Q-1);
}
      
   energy[0] = sumenergy / volume;
   magsq[0] = mag[0] * mag[0];
   /* Work out anti-ferro magnetization */
   if (!ferromag) {
      mag[1] = magn(spin);
   }
   cntenergy++;
   cntspin++;

}



/* Anti-ferromagnetic magnetization */

float magn(spin)
short spin[IMAX][JMAX];
{
  int odd_or_even,mg[MAXQ],total;
  int i,j,m;
  float norm_total;

  odd_or_even = -1;
  for (m=0;m<Q;m++) 
     mg[m] = 0;
  for (i=0;i<isiz;i++) {
     for (j=0;j<jsiz;j++) {
	odd_or_even = - odd_or_even;
        for (m=0;m<Q;m++) {
	   if ( m == spin[i][j] ) {
	      mg[m] += odd_or_even;
	   }
	}
     }
     odd_or_even = -odd_or_even;
  }
  total = 0;
  for (m=0;m<Q;m++) {
     if ( mg[m] < 0 ) mg[m] = - mg[m];
     total += mg[m];
  }
  norm_total = 2.0 * (double)total / (double)(volume*Q);
  return norm_total;
}


